<!DOCTYPE html>
<html lang="en" xmlns:th="http://www.thymeleaf.org">
<head>
<meta charset="ISO-8859-1">
<title>Distran</title>
	<script src="https://cdn.jsdelivr.net/npm/hls.js@latest"></script>
	<script src="http://localhost:8080/distranbroker/viewer.js" ></script>
</head>
<body>
<p>Distran - Distributed Transcoded - Viewer</p>
<br>
<main role="main" class="container">
	<p>Playing the file <span th:text="${fileURL}" /></p>
    <video height="480" id="video" controls>
		<source th:type="${mediaType}" th:src="${fileURL}">    
    </video>
</main>
    <script>
      var video = document.getElementById('video');
      var source = video.firstElementChild.getAttribute("src");
      
      var tracker = new UtilityTracker("viewer" + Math.floor(Math.random() * 1000));
      
      setInterval(function() {
    	  console.log('Sending feedback...');
    	  var feedbacks = JSON.stringify(tracker.aggregateUtilityFeedback());
    	  fetch("http://localhost:8080/distranbroker/feedback", {
    		  method: 'POST',
    		  headers: {
    			  'Accept': 'application/json',
    			  'Content-type': 'application/json'
    		  },
    		  body: feedbacks
    	  });
      }, 5000);
      
      if (Hls.isSupported()) {
        var hls = new Hls({
          debug: true,
        });
        
        hls.loadSource(source);
        hls.attachMedia(video);
        
        hls.on(Hls.Events.MEDIA_ATTACHED, function () {
          video.play();
        });
        
        hls.on(Hls.Events.FRAG_LOADING, function(event, data){
        	tracker.addSegment(data.frag.url, data.frag.duration);
        });
        
        hls.on(Hls.Events.FRAG_LOADED, function(event, data){
        	const url = data.frag.url;
        	const seg = tracker.markSegmentReceived(url, data.frag.stats.total);
        });        
      }
      // hls.js is not supported on platforms that do not have Media Source Extensions (MSE) enabled.
      // When the browser has built-in HLS support (check using `canPlayType`), we can provide an HLS manifest (i.e. .m3u8 URL) directly to the video element throught the `src` property.
      // This is using the built-in support of the plain video element, without using hls.js.
      else if (video.canPlayType('application/vnd.apple.mpegurl')) {
        video.src = source;
        video.addEventListener('canplay', function () {
          video.play();
        });
      }
    </script>
</body>
</html>